package com.eksad.masterdata.domain;

import com.eksad.ddms.common.util.object.EntityObject;

import jakarta.persistence.*;
import java.util.Objects;

@Entity
@Table(name= "TRX_COMPLAINTWO")
public class ComplaintWorkOrder implements EntityObject<ComplaintWorkOrder> {

    @Id
    @GeneratedValue(generator = "trx_complaintwo_gen")
    @SequenceGenerator(name = "trx_complaintwo_gen", sequenceName = "trx_complaintwo_seq")
    Integer id;
    private String complaintWoID;
    private String complaintID;
    private String complaintName;
    private String analisa;
    private String woID;
    @Embedded
    private CreationalSpecification complaintWoCreational;

    public ComplaintWorkOrder() {
    }

    public ComplaintWorkOrder(String complaintWoID, String complaintID, String complaintName, String analisa, String woID, CreationalSpecification complaintWoCreational) {
        this.complaintWoID = complaintWoID;
        this.complaintID = complaintID;
        this.complaintName = complaintName;
        this.analisa = analisa;
        this.woID = woID;
        this.complaintWoCreational = complaintWoCreational;
    }

    public String getAnalisa() {
        return analisa;
    }

    public void setAnalisa(String analisa) {
        this.analisa = analisa;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getComplaintWoID() {
        return complaintWoID;
    }

    public void setComplaintWoID(String complaintWoID) {
        this.complaintWoID = complaintWoID;
    }

    public String getComplaintID() {
        return complaintID;
    }

    public void setComplaintID(String complaintID) {
        this.complaintID = complaintID;
    }

    public String getComplaintName() {
        return complaintName;
    }

    public void setComplaintName(String complaintName) {
        this.complaintName = complaintName;
    }

    public String getWoID() {
        return woID;
    }

    public void setWoID(String woID) {
        this.woID = woID;
    }

    public CreationalSpecification getComplaintWoCreational() {
        return complaintWoCreational;
    }

    public void setComplaintWoCreational(CreationalSpecification complaintWoCreational) {
        this.complaintWoCreational = complaintWoCreational;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 11 * hash + Objects.hashCode(this.complaintWoID);
        hash = 11 * hash + Objects.hashCode(this.complaintID);
        hash = 11 * hash + Objects.hashCode(this.complaintName);
        hash = 11 * hash + Objects.hashCode(this.analisa);
        hash = 11 * hash + Objects.hashCode(this.woID);
        hash = 11 * hash + Objects.hashCode(this.complaintWoCreational);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final ComplaintWorkOrder other = (ComplaintWorkOrder) obj;
        if (!Objects.equals(this.complaintWoID, other.complaintWoID)) {
            return false;
        }
        if (!Objects.equals(this.complaintID, other.complaintID)) {
            return false;
        }
        if (!Objects.equals(this.complaintName, other.complaintName)) {
            return false;
        }
        if (!Objects.equals(this.analisa, other.analisa)) {
            return false;
        }
        if (!Objects.equals(this.woID, other.woID)) {
            return false;
        }
        if (!Objects.equals(this.complaintWoCreational, other.complaintWoCreational)) {
            return false;
        }
        return true;
    }

    @Override
    public boolean sameIdentityAs(ComplaintWorkOrder t) {
        return this.equals(t);
    }
}
