package com.eksad.masterdata.domain;

import com.eksad.ddms.common.type.PromoWOType;
import com.eksad.ddms.common.util.object.EntityObject;
import com.eksad.ddms.common.util.status.DataStatus;

import jakarta.persistence.*;
import java.util.Objects;

@Entity
@Table(name= "MST_PROMOWORKORDERDETAIL")
public class PromoWorkOrderDetail implements EntityObject<PromoWorkOrderDetail> {

    @Id
    @GeneratedValue(generator = "mst_promoworkorderdetail_gen")
    @SequenceGenerator(name = "mst_promoworkorderdetail_gen", sequenceName = "mst_promoworkorderdetail_seq")
    Integer id;

    private String promoWoID;
    private String woID;
    private String ahassID;
    @Enumerated(EnumType.STRING)
    private PromoWOType type;
    private String referenceID;
    private Double value;
    @Enumerated(EnumType.STRING)
    private DataStatus status;
    private Boolean isManualPromo;

    @Embedded
    private CreationalSpecification promoWoDetailCreational;

    public PromoWorkOrderDetail() {
    }

    public PromoWorkOrderDetail(String promoWoID, String woID, String ahassID, PromoWOType type, String referenceID,
                                Double value, DataStatus status, CreationalSpecification promoWoDetailCreational) {

        this.promoWoID = promoWoID;
        this.woID = woID;
        this.ahassID = ahassID;
        this.type = type;
        this.referenceID = referenceID;
        this.value = value;
        this.status = status;
        this.promoWoDetailCreational = promoWoDetailCreational;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getPromoWoID() {
        return promoWoID;
    }

    public void setPromoWoID(String promoWoID) {
        this.promoWoID = promoWoID;
    }

    public String getWoID() {
        return woID;
    }

    public void setWoID(String woID) {
        this.woID = woID;
    }

    public String getAhassID() {
        return ahassID;
    }

    public void setAhassID(String ahassID) {
        this.ahassID = ahassID;
    }

    public PromoWOType getType() {
        return type;
    }

    public void setType(PromoWOType type) {
        this.type = type;
    }

    public String getReferenceID() {
        return referenceID;
    }

    public void setReferenceID(String referenceID) {
        this.referenceID = referenceID;
    }

    public Double getValue() {
        return value;
    }

    public void setValue(Double value) {
        this.value = value;
    }

    public DataStatus getStatus() {
        return status;
    }

    public void setStatus(DataStatus status) {
        this.status = status;
    }

    public Boolean getIsManualPromo() {
        return isManualPromo;
    }

    public void setIsManualPromo(Boolean isManualPromo) {
        this.isManualPromo = isManualPromo;
    }

    public CreationalSpecification getPromoWoDetailCreational() {
        return promoWoDetailCreational;
    }

    public void setPromoWoDetailCreational(CreationalSpecification promoWoDetailCreational) {
        this.promoWoDetailCreational = promoWoDetailCreational;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 71 * hash + Objects.hashCode(this.id);
        hash = 71 * hash + Objects.hashCode(this.promoWoID);
        hash = 71 * hash + Objects.hashCode(this.woID);
        hash = 71 * hash + Objects.hashCode(this.ahassID);
        hash = 71 * hash + Objects.hashCode(this.type);
        hash = 71 * hash + Objects.hashCode(this.referenceID);
        hash = 71 * hash + Objects.hashCode(this.value);
        hash = 71 * hash + Objects.hashCode(this.status);
        hash = 71 * hash + Objects.hashCode(this.isManualPromo);
        hash = 71 * hash + Objects.hashCode(this.promoWoDetailCreational);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final PromoWorkOrderDetail other = (PromoWorkOrderDetail) obj;
        if (!Objects.equals(this.id, other.id)) {
            return false;
        }
        if (!Objects.equals(this.promoWoID, other.promoWoID)) {
            return false;
        }
        if (!Objects.equals(this.woID, other.woID)) {
            return false;
        }
        if (!Objects.equals(this.ahassID, other.ahassID)) {
            return false;
        }
        if (!Objects.equals(this.type, other.type)) {
            return false;
        }
        if (!Objects.equals(this.referenceID, other.referenceID)) {
            return false;
        }
        if (!Objects.equals(this.value, other.value)) {
            return false;
        }
        if (!Objects.equals(this.status, other.status)) {
            return false;
        }
        if (!Objects.equals(this.isManualPromo, other.isManualPromo)) {
            return false;
        }
        if (!Objects.equals(this.promoWoDetailCreational, other.promoWoDetailCreational)) {
            return false;
        }
        return true;
    }

    @Override
    public boolean sameIdentityAs(PromoWorkOrderDetail t) {
        return this.equals(t);
    }
}
