package com.eksad.masterdata.domain;

import com.eksad.ddms.common.util.object.EntityObject;

import jakarta.persistence.*;

import javax.validation.constraints.NotNull;
import java.util.Objects;

@Entity
@Table(name = "TRX_WOSERVICE")
public class WorkOrderService implements EntityObject<WorkOrderService> {

    @Id
    @GeneratedValue(generator = "trx_woservice_gen")
    @SequenceGenerator(name = "trx_woservice_gen", sequenceName = "trx_woservice_seq")
    Integer id;

    @NotNull(message="Work Order Service ID cannot be null")
    String workOrderServiceID;
    String configWorkshopServiceID;
    String source;
    Double harga;
    Integer qty;
    Boolean c2;
    Boolean kpb;
    Double discount;
    Double total;
    String woID;
    Double ppnRate;
    Double ppnAmount;
    Boolean isKmRegular;
    Double claimDiscount;
    Boolean isContractService;
    String csPackageCode;
//    Double ppnrate;
//    Double ppnamount;

    @Embedded
    private CreationalSpecification workOrderServiceCreational;

    public WorkOrderService() {
    }


    public WorkOrderService(String workOrderServiceID, String configWorkshopServiceID, String source, Double harga, Integer qty, Boolean c2, Boolean kpb, Double discount, Double total, String woID, Boolean isKmRegular, Double claimDiscount,Double ppnRate,Double ppnAmount, Boolean isContractService, String csPackageCode, CreationalSpecification workOrderServiceCreational) {
        this.workOrderServiceID = workOrderServiceID;
        this.configWorkshopServiceID = configWorkshopServiceID;
        this.source = source;
        this.harga = harga;
        this.qty = qty;
        this.c2 = c2;
        this.kpb = kpb;
        this.discount = discount;
        this.total = total;
        this.woID = woID;
        this.isKmRegular = isKmRegular;
        this.claimDiscount = claimDiscount;
        this.ppnRate=ppnRate;
        this.ppnAmount=ppnAmount;
        this.isContractService = isContractService;
        this.csPackageCode = csPackageCode;
        this.workOrderServiceCreational = workOrderServiceCreational;
    }

    public Double getHarga() {
        return harga;
    }

    public void setHarga(Double harga) {
        this.harga = harga;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getWorkOrderServiceID() {
        return workOrderServiceID;
    }

    public void setWorkOrderServiceID(String workOrderServiceID) {
        this.workOrderServiceID = workOrderServiceID;
    }

    public String getConfigWorkshopServiceID() {
        return configWorkshopServiceID;
    }

    public void setConfigWorkshopServiceID(String configWorkshopServiceID) {
        this.configWorkshopServiceID = configWorkshopServiceID;
    }



    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }



    public Integer getQty() {
        return qty;
    }

    public void setQty(Integer qty) {
        this.qty = qty;
    }

    public Boolean getC2() {
        return c2;
    }

    public void setC2(Boolean c2) {
        this.c2 = c2;
    }

    public Boolean getKpb() {
        return kpb;
    }

    public void setKpb(Boolean kpb) {
        this.kpb = kpb;
    }

    public Double getDiscount() {
        return discount;
    }

    public void setDiscount(Double discount) {
        this.discount = discount;
    }

    public Double getTotal() {
        return total;
    }

    public void setTotal(Double total) {
        this.total = total;
    }

    public String getWoID() {
        return woID;
    }

    public void setWoID(String woID) {
        this.woID = woID;
    }

    public Boolean getIsKmRegular() {
        return isKmRegular;
    }

    public void setIsKmRegular(Boolean isKmRegular) {
        this.isKmRegular = isKmRegular;
    }

    public Double getClaimDiscount() {
        return claimDiscount;
    }

    public void setClaimDiscount(Double claimDiscount) {
        this.claimDiscount = claimDiscount;
    }

    public Double getPpnRate() {
        return ppnRate;
    }

    public void setPpnRate(Double ppnRate) {
        this.ppnRate = ppnRate;
    }

    public Double getPpnAmount() {
        return ppnAmount;
    }

    public void setPpnAmount(Double ppnAmount) {
        this.ppnAmount = ppnAmount;
    }


    public CreationalSpecification getWorkOrderServiceCreational() {
        return workOrderServiceCreational;
    }

    public void setWorkOrderServiceCreational(CreationalSpecification workOrderServiceCreational) {
        this.workOrderServiceCreational = workOrderServiceCreational;
    }

    public Boolean getIsContractService() {
        return isContractService;
    }


    public void setIsContractService(Boolean isContractService) {
        this.isContractService = isContractService;
    }

    public String getCsPackageCode() {
        return csPackageCode;
    }

    public void setCsPackageCode(String csPackageCode) {
        this.csPackageCode = csPackageCode;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 23 * hash + Objects.hashCode(this.id);
        hash = 23 * hash + Objects.hashCode(this.workOrderServiceID);
        hash = 23 * hash + Objects.hashCode(this.configWorkshopServiceID);
        hash = 23 * hash + Objects.hashCode(this.source);
        hash = 23 * hash + Objects.hashCode(this.harga);
        hash = 23 * hash + Objects.hashCode(this.qty);
        hash = 23 * hash + Objects.hashCode(this.c2);
        hash = 23 * hash + Objects.hashCode(this.kpb);
        hash = 23 * hash + Objects.hashCode(this.discount);
        hash = 23 * hash + Objects.hashCode(this.total);
        hash = 23 * hash + Objects.hashCode(this.woID);
        hash = 23 * hash + Objects.hashCode(this.isKmRegular);
        hash = 23 * hash + Objects.hashCode(this.claimDiscount);
        hash = 23 * hash + Objects.hashCode(this.ppnRate);
        hash = 23 * hash + Objects.hashCode(this.ppnAmount);
        hash = 23 * hash + Objects.hashCode(this.workOrderServiceCreational);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final WorkOrderService other = (WorkOrderService) obj;
        if (!Objects.equals(this.workOrderServiceID, other.workOrderServiceID)) {
            return false;
        }
        if (!Objects.equals(this.configWorkshopServiceID, other.configWorkshopServiceID)) {
            return false;
        }
        if (!Objects.equals(this.source, other.source)) {
            return false;
        }
        if (!Objects.equals(this.woID, other.woID)) {
            return false;
        }
        if (!Objects.equals(this.id, other.id)) {
            return false;
        }
        if (!Objects.equals(this.harga, other.harga)) {
            return false;
        }
        if (!Objects.equals(this.qty, other.qty)) {
            return false;
        }
        if (!Objects.equals(this.c2, other.c2)) {
            return false;
        }
        if (!Objects.equals(this.kpb, other.kpb)) {
            return false;
        }
        if (!Objects.equals(this.discount, other.discount)) {
            return false;
        }
        if (!Objects.equals(this.total, other.total)) {
            return false;
        }
        if (!Objects.equals(this.isKmRegular, other.isKmRegular)) {
            return false;
        }
        if (!Objects.equals(this.claimDiscount, other.claimDiscount)) {
            return false;
        }
        if (!Objects.equals(this.ppnRate, other.ppnRate)) {
            return false;
        }
        if (!Objects.equals(this.ppnAmount, other.ppnAmount)) {
            return false;
        }
        if (!Objects.equals(this.workOrderServiceCreational, other.workOrderServiceCreational)) {
            return false;
        }
        return true;
    }

    @Override
    public boolean sameIdentityAs(WorkOrderService other) {
        return this.equals(other);
    }
}
