package com.eksad.masterdata.domain;


import com.eksad.ddms.common.util.object.EntityObject;

import jakarta.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Objects;

@Entity
@Table(name = "TRX_WOSPAREPART")
public class WorkOrderSparepart implements EntityObject<WorkOrderSparepart> {

    @Id
    @GeneratedValue(generator = "trx_wosparepart_gen")
    @SequenceGenerator(name = "trx_wosparepart_gen", sequenceName = "trx_wosparepart_seq")
    Integer id;

    @NotNull(message="Work Order Service ID cannot be null")
    String woSparepartID;
    String partID;
    Integer qty;
    Boolean c2;
    Double discount;
    Double total;
    String woID;
    String source;
    Boolean KPB;
    Double harga;
    Double ppnRate;
    Double ppnAmount;
    Double claimDiscount;
//    Double ppnrate;
//    Double ppnamount;

    @Embedded
    private CreationalSpecification workOrderServiceCreational;

    public WorkOrderSparepart() {
    }

    public WorkOrderSparepart(String woSparepartID, String partID, Integer qty, Boolean c2, Double discount, Double total, String woID, String source, Boolean KPB, Double harga, Double claimDiscount,Double ppnRate, Double ppnAmount,CreationalSpecification workOrderServiceCreational) {
        this.woSparepartID = woSparepartID;
        this.partID = partID;
        this.qty = qty;
        this.c2 = c2;
        this.discount = discount;
        this.total = total;
        this.woID = woID;
        this.source = source;
        this.KPB = KPB;
        this.harga = harga;
        this.claimDiscount = claimDiscount;
        this.ppnRate=ppnRate;
        this.ppnAmount=ppnAmount;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getPartID() {
        return partID;
    }

    public void setPartID(String partID) {
        this.partID = partID;
    }

    public String getWoSparepartID() {
        return woSparepartID;
    }

    public void setWoSparepartID(String woSparepartID) {
        this.woSparepartID = woSparepartID;
    }

    public Integer getQty() {
        return qty;
    }

    public void setQty(Integer qty) {
        this.qty = qty;
    }

    public Boolean getC2() {
        return c2;
    }

    public void setC2(Boolean c2) {
        this.c2 = c2;
    }

    public Double getDiscount() {
        return discount;
    }

    public void setDiscount(Double discount) {
        this.discount = discount;
    }

    public Double getTotal() {
        return total;
    }

    public void setTotal(Double total) {
        this.total = total;
    }

    public String getWoID() {
        return woID;
    }

    public void setWoID(String woID) {
        this.woID = woID;
    }

    public CreationalSpecification getWorkOrderServiceCreational() {
        return workOrderServiceCreational;
    }

    public void setWorkOrderServiceCreational(CreationalSpecification workOrderServiceCreational) {
        this.workOrderServiceCreational = workOrderServiceCreational;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public Boolean getKPB() {
        return KPB;
    }

    public void setKPB(Boolean kPB) {
        KPB = kPB;
    }

    public Double getHarga() {
        return harga;
    }

    public void setHarga(Double harga) {
        this.harga = harga;
    }

    public Double getClaimDiscount() {
        return claimDiscount;
    }

    public void setClaimDiscount(Double claimDiscount) {
        this.claimDiscount = claimDiscount;
    }

    public Double getPpnRate() {
        return ppnRate;
    }

    public void setPpnRate(Double ppnRate) {
        this.ppnRate = ppnRate;
    }

    public Double getPpnAmount() {
        return ppnAmount;
    }

    public void setPpnAmount(Double ppnAmount) {
        this.ppnAmount = ppnAmount;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 31 * hash + Objects.hashCode(this.id);
        hash = 31 * hash + Objects.hashCode(this.woSparepartID);
        hash = 31 * hash + Objects.hashCode(this.partID);
        hash = 31 * hash + Objects.hashCode(this.qty);
        hash = 31 * hash + Objects.hashCode(this.c2);
        hash = 31 * hash + Objects.hashCode(this.discount);
        hash = 31 * hash + Objects.hashCode(this.total);
        hash = 31 * hash + Objects.hashCode(this.woID);
        hash = 31 * hash + Objects.hashCode(this.source);
        hash = 31 * hash + Objects.hashCode(this.KPB);
        hash = 31 * hash + Objects.hashCode(this.harga);
        hash = 31 * hash + Objects.hashCode(this.claimDiscount);
        hash = 31 * hash + Objects.hashCode(this.ppnRate);
        hash = 31 * hash + Objects.hashCode(this.ppnAmount);
        hash = 31 * hash + Objects.hashCode(this.workOrderServiceCreational);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final WorkOrderSparepart other = (WorkOrderSparepart) obj;
        if (!Objects.equals(this.woSparepartID, other.woSparepartID)) {
            return false;
        }
        if (!Objects.equals(this.partID, other.partID)) {
            return false;
        }
        if (!Objects.equals(this.woID, other.woID)) {
            return false;
        }
        if (!Objects.equals(this.source, other.source)) {
            return false;
        }
        if (!Objects.equals(this.id, other.id)) {
            return false;
        }
        if (!Objects.equals(this.qty, other.qty)) {
            return false;
        }
        if (!Objects.equals(this.c2, other.c2)) {
            return false;
        }
        if (!Objects.equals(this.discount, other.discount)) {
            return false;
        }
        if (!Objects.equals(this.total, other.total)) {
            return false;
        }
        if (!Objects.equals(this.KPB, other.KPB)) {
            return false;
        }
        if (!Objects.equals(this.harga, other.harga)) {
            return false;
        }
        if (!Objects.equals(this.claimDiscount, other.claimDiscount)) {
            return false;
        }
        if (!Objects.equals(this.ppnRate, other.ppnRate)) {
            return false;
        }
        if (!Objects.equals(this.ppnAmount, other.ppnAmount)) {
            return false;
        }
        if (!Objects.equals(this.workOrderServiceCreational, other.workOrderServiceCreational)) {
            return false;
        }
        return true;
    }

    @Override
    public boolean sameIdentityAs(WorkOrderSparepart other) {
        return this.equals(other);
    }
}
